/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.302 Revision 1.421
1# Copyright 1999-2007 Gentoo Foundation 1# Copyright 1999-2013 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.302 2008/08/17 22:21:52 opfer Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.421 2013/05/22 05:10:29 mgorny Exp $
4 4
5# @ECLASS: eutils.eclass 5# @ECLASS: eutils.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# base-system@gentoo.org 7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds 8# @BLURB: many extra (but common) functions that are used in ebuilds
13# home rather than having multiple ebuilds implementing the same thing. 13# home rather than having multiple ebuilds implementing the same thing.
14# 14#
15# Due to the nature of this eclass, some functions may have maintainers 15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass! 16# different from the overall eclass!
17 17
18inherit multilib portability 18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
19 20
20DESCRIPTION="Based on the ${ECLASS} eclass" 21inherit multilib toolchain-funcs user
22
23if has "${EAPI:-0}" 0 1 2; then
21 24
22# @FUNCTION: epause 25# @FUNCTION: epause
23# @USAGE: [seconds] 26# @USAGE: [seconds]
24# @DESCRIPTION: 27# @DESCRIPTION:
25# Sleep for the specified number of seconds (default of 5 seconds). Useful when 28# Sleep for the specified number of seconds (default of 5 seconds). Useful when
26# printing a message the user should probably be reading and often used in 29# printing a message the user should probably be reading and often used in
27# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set, 30# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
28# don't wait at all. 31# don't wait at all. Defined in EAPIs 0 1 and 2.
29epause() { 32epause() {
30 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5} 33 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
31} 34}
32 35
33# @FUNCTION: ebeep 36# @FUNCTION: ebeep
34# @USAGE: [number of beeps] 37# @USAGE: [number of beeps]
35# @DESCRIPTION: 38# @DESCRIPTION:
36# Issue the specified number of beeps (default of 5 beeps). Useful when 39# Issue the specified number of beeps (default of 5 beeps). Useful when
37# printing a message the user should probably be reading and often used in 40# printing a message the user should probably be reading and often used in
38# conjunction with the epause function. If the EBEEP_IGNORE env var is set, 41# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
39# don't beep at all. 42# don't beep at all. Defined in EAPIs 0 1 and 2.
40ebeep() { 43ebeep() {
41 local n 44 local n
42 if [[ -z ${EBEEP_IGNORE} ]] ; then 45 if [[ -z ${EBEEP_IGNORE} ]] ; then
43 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 46 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
44 echo -ne "\a" 47 echo -ne "\a"
47 sleep 1 50 sleep 1
48 done 51 done
49 fi 52 fi
50} 53}
51 54
55else
56
57ebeep() {
58 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
59}
60
61epause() {
62 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
63}
64
65fi
66
67# @FUNCTION: eqawarn
68# @USAGE: [message]
69# @DESCRIPTION:
70# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
71# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
72# profile.
73if ! declare -F eqawarn >/dev/null ; then
74 eqawarn() {
75 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
76 :
77 }
78fi
79
52# @FUNCTION: ecvs_clean 80# @FUNCTION: ecvs_clean
53# @USAGE: [list of dirs] 81# @USAGE: [list of dirs]
54# @DESCRIPTION: 82# @DESCRIPTION:
55# Remove CVS directories recursiveley. Useful when a source tarball contains 83# Remove CVS directories recursiveley. Useful when a source tarball contains
56# internal CVS directories. Defaults to $PWD. 84# internal CVS directories. Defaults to $PWD.
68esvn_clean() { 96esvn_clean() {
69 [[ -z $* ]] && set -- . 97 [[ -z $* ]] && set -- .
70 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf 98 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
71} 99}
72 100
73# Default directory where patches are located 101# @FUNCTION: estack_push
102# @USAGE: <stack> [items to push]
103# @DESCRIPTION:
104# Push any number of items onto the specified stack. Pick a name that
105# is a valid variable (i.e. stick to alphanumerics), and push as many
106# items as you like onto the stack at once.
107#
108# The following code snippet will echo 5, then 4, then 3, then ...
109# @CODE
110# estack_push mystack 1 2 3 4 5
111# while estack_pop mystack i ; do
112# echo "${i}"
113# done
114# @CODE
115estack_push() {
116 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
117 local stack_name="__ESTACK_$1__" ; shift
118 eval ${stack_name}+=\( \"\$@\" \)
119}
120
121# @FUNCTION: estack_pop
122# @USAGE: <stack> [variable]
123# @DESCRIPTION:
124# Pop a single item off the specified stack. If a variable is specified,
125# the popped item is stored there. If no more items are available, return
126# 1, else return 0. See estack_push for more info.
127estack_pop() {
128 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
129
130 # We use the fugly __estack_xxx var names to avoid collision with
131 # passing back the return value. If we used "local i" and the
132 # caller ran `estack_pop ... i`, we'd end up setting the local
133 # copy of "i" rather than the caller's copy. The __estack_xxx
134 # garbage is preferable to using $1/$2 everywhere as that is a
135 # bit harder to read.
136 local __estack_name="__ESTACK_$1__" ; shift
137 local __estack_retvar=$1 ; shift
138 eval local __estack_i=\${#${__estack_name}\[@\]}
139 # Don't warn -- let the caller interpret this as a failure
140 # or as normal behavior (akin to `shift`)
141 [[ $(( --__estack_i )) -eq -1 ]] && return 1
142
143 if [[ -n ${__estack_retvar} ]] ; then
144 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
145 fi
146 eval unset ${__estack_name}\[${__estack_i}\]
147}
148
149# @FUNCTION: eshopts_push
150# @USAGE: [options to `set` or `shopt`]
151# @DESCRIPTION:
152# Often times code will want to enable a shell option to change code behavior.
153# Since changing shell options can easily break other pieces of code (which
154# assume the default state), eshopts_push is used to (1) push the current shell
155# options onto a stack and (2) pass the specified arguments to set.
156#
157# If the first argument is '-s' or '-u', we assume you want to call `shopt`
158# rather than `set` as there are some options only available via that.
159#
160# A common example is to disable shell globbing so that special meaning/care
161# may be used with variables/arguments to custom functions. That would be:
162# @CODE
163# eshopts_push -s noglob
164# for x in ${foo} ; do
165# if ...some check... ; then
166# eshopts_pop
167# return 0
168# fi
169# done
170# eshopts_pop
171# @CODE
172eshopts_push() {
173 if [[ $1 == -[su] ]] ; then
174 estack_push eshopts "$(shopt -p)"
175 [[ $# -eq 0 ]] && return 0
176 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
177 else
178 estack_push eshopts $-
179 [[ $# -eq 0 ]] && return 0
180 set "$@" || die "${FUNCNAME}: bad options to set: $*"
181 fi
182}
183
184# @FUNCTION: eshopts_pop
185# @USAGE:
186# @DESCRIPTION:
187# Restore the shell options to the state saved with the corresponding
188# eshopts_push call. See that function for more details.
189eshopts_pop() {
190 local s
191 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
192 if [[ ${s} == "shopt -"* ]] ; then
193 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
194 else
195 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
196 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
197 fi
198}
199
200# @FUNCTION: eumask_push
201# @USAGE: <new umask>
202# @DESCRIPTION:
203# Set the umask to the new value specified while saving the previous
204# value onto a stack. Useful for temporarily changing the umask.
205eumask_push() {
206 estack_push eumask "$(umask)"
207 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
208}
209
210# @FUNCTION: eumask_pop
211# @USAGE:
212# @DESCRIPTION:
213# Restore the previous umask state.
214eumask_pop() {
215 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
216 local s
217 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
218 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
219}
220
221# @VARIABLE: EPATCH_SOURCE
222# @DESCRIPTION:
223# Default directory to search for patches.
74EPATCH_SOURCE="${WORKDIR}/patch" 224EPATCH_SOURCE="${WORKDIR}/patch"
75# Default extension for patches 225# @VARIABLE: EPATCH_SUFFIX
226# @DESCRIPTION:
227# Default extension for patches (do not prefix the period yourself).
76EPATCH_SUFFIX="patch.bz2" 228EPATCH_SUFFIX="patch.bz2"
77# Default options for patch 229# @VARIABLE: EPATCH_OPTS
230# @DESCRIPTION:
231# Options to pass to patch. Meant for ebuild/package-specific tweaking
232# such as forcing the patch level (-p#) or fuzz (-F#) factor. Note that
233# for single patch tweaking, you can also pass flags directly to epatch.
234EPATCH_OPTS=""
235# @VARIABLE: EPATCH_COMMON_OPTS
236# @DESCRIPTION:
237# Common options to pass to `patch`. You probably should never need to
238# change these. If you do, please discuss it with base-system first to
239# be sure.
240# @CODE
78# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 241# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
79# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 242# --no-backup-if-mismatch - do not leave .orig files behind
80# Set -E to automatically remove empty files. 243# -E - automatically remove empty files
244# @CODE
81EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 245EPATCH_COMMON_OPTS="-g0 -E --no-backup-if-mismatch"
246# @VARIABLE: EPATCH_EXCLUDE
247# @DESCRIPTION:
82# List of patches not to apply. Not this is only file names, 248# List of patches not to apply. Note this is only file names,
83# and not the full path .. 249# and not the full path. Globs accepted.
84EPATCH_EXCLUDE="" 250EPATCH_EXCLUDE=""
251# @VARIABLE: EPATCH_SINGLE_MSG
252# @DESCRIPTION:
85# Change the printed message for a single patch. 253# Change the printed message for a single patch.
86EPATCH_SINGLE_MSG="" 254EPATCH_SINGLE_MSG=""
255# @VARIABLE: EPATCH_MULTI_MSG
256# @DESCRIPTION:
87# Change the printed message for multiple patches. 257# Change the printed message for multiple patches.
88EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 258EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
89# Force applying bulk patches even if not following the style: 259# @VARIABLE: EPATCH_FORCE
90# 260# @DESCRIPTION:
91# ??_${ARCH}_foo.${EPATCH_SUFFIX} 261# Only require patches to match EPATCH_SUFFIX rather than the extended
92# 262# arch naming style.
93EPATCH_FORCE="no" 263EPATCH_FORCE="no"
264# @VARIABLE: EPATCH_USER_EXCLUDE
265# @DEFAULT_UNSET
266# @DESCRIPTION:
267# List of patches not to apply. Note this is only file names,
268# and not the full path. Globs accepted.
94 269
95# This function is for bulk patching, or in theory for just one 270# @FUNCTION: epatch
96# or two patches. 271# @USAGE: [options] [patches] [dirs of patches]
272# @DESCRIPTION:
273# epatch is designed to greatly simplify the application of patches. It can
274# process patch files directly, or directories of patches. The patches may be
275# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
276# the -p option as epatch will automatically attempt -p0 to -p5 until things
277# apply successfully.
97# 278#
98# It should work with .bz2, .gz, .zip and plain text patches. 279# If you do not specify any patches/dirs, then epatch will default to the
99# Currently all patches should be the same format. 280# directory specified by EPATCH_SOURCE.
100# 281#
101# You do not have to specify '-p' option to patch, as it will 282# Any options specified that start with a dash will be passed down to patch
102# try with -p0 to -p5 until it succeed, or fail at -p5. 283# for this specific invocation. As soon as an arg w/out a dash is found, then
284# arg processing stops.
103# 285#
104# Above EPATCH_* variables can be used to control various defaults, 286# When processing directories, epatch will apply all patches that match:
105# bug they should be left as is to ensure an ebuild can rely on 287# @CODE
106# them for. 288# if ${EPATCH_FORCE} != "yes"
107#
108# Patches are applied in current directory.
109#
110# Bulk Patches should preferibly have the form of:
111#
112# ??_${ARCH}_foo.${EPATCH_SUFFIX} 289# ??_${ARCH}_foo.${EPATCH_SUFFIX}
290# else
291# *.${EPATCH_SUFFIX}
292# @CODE
293# The leading ?? are typically numbers used to force consistent patch ordering.
294# The arch field is used to apply patches only for the host architecture with
295# the special value of "all" means apply for everyone. Note that using values
296# other than "all" is highly discouraged -- you should apply patches all the
297# time and let architecture details be detected at configure/compile time.
113# 298#
114# For example: 299# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
300# for patches to apply.
115# 301#
116# 01_all_misc-fix.patch.bz2 302# Refer to the other EPATCH_xxx variables for more customization of behavior.
117# 02_sparc_another-fix.patch.bz2
118#
119# This ensures that there are a set order, and you can have ARCH
120# specific patches.
121#
122# If you however give an argument to epatch(), it will treat it as a
123# single patch that need to be applied if its a file. If on the other
124# hand its a directory, it will set EPATCH_SOURCE to this.
125#
126# <azarah@gentoo.org> (10 Nov 2002)
127#
128epatch() { 303epatch() {
129 _epatch_draw_line() { 304 _epatch_draw_line() {
305 # create a line of same length as input string
130 [[ -z $1 ]] && set "$(printf "%65s" '')" 306 [[ -z $1 ]] && set "$(printf "%65s" '')"
131 echo "${1//?/=}" 307 echo "${1//?/=}"
132 } 308 }
133 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
134 local PIPE_CMD=""
135 local STDERR_TARGET="${T}/$$.out"
136 local PATCH_TARGET="${T}/$$.patch"
137 local PATCH_SUFFIX=""
138 local SINGLE_PATCH="no"
139 local x=""
140 309
141 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 310 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
142 311
143 if [ "$#" -gt 1 ] 312 # First process options. We localize the EPATCH_OPTS setting
144 then 313 # from above so that we can pass it on in the loop below with
314 # any additional values the user has specified.
315 local EPATCH_OPTS=( ${EPATCH_OPTS[*]} )
316 while [[ $# -gt 0 ]] ; do
317 case $1 in
318 -*) EPATCH_OPTS+=( "$1" ) ;;
319 *) break ;;
320 esac
321 shift
322 done
323
324 # Let the rest of the code process one user arg at a time --
325 # each arg may expand into multiple patches, and each arg may
326 # need to start off with the default global EPATCH_xxx values
327 if [[ $# -gt 1 ]] ; then
145 local m="" 328 local m
146 for m in "$@" ; do 329 for m in "$@" ; do
147 epatch "${m}" 330 epatch "${m}"
148 done 331 done
149 return 0 332 return 0
150 fi 333 fi
151 334
152 if [ -n "$1" -a -f "$1" ] 335 local SINGLE_PATCH="no"
153 then 336 # no args means process ${EPATCH_SOURCE}
337 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
338
339 if [[ -f $1 ]] ; then
154 SINGLE_PATCH="yes" 340 SINGLE_PATCH="yes"
155 341 set -- "$1"
156 local EPATCH_SOURCE="$1" 342 # Use the suffix from the single patch (localize it); the code
343 # below will find the suffix for us
157 local EPATCH_SUFFIX="${1##*\.}" 344 local EPATCH_SUFFIX=$1
158 345
159 elif [ -n "$1" -a -d "$1" ] 346 elif [[ -d $1 ]] ; then
160 then 347 # Some people like to make dirs of patches w/out suffixes (vim)
161 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 348 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
162 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 349
350 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
351 # Re-use EPATCH_SOURCE as a search dir
352 epatch "${EPATCH_SOURCE}/$1"
353 return $?
354
355 else
356 # sanity check ... if it isn't a dir or file, wtf man ?
357 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
358 echo
359 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
360 eerror
361 eerror " ${EPATCH_SOURCE}"
362 eerror " ( ${EPATCH_SOURCE##*/} )"
363 echo
364 die "Cannot find \$EPATCH_SOURCE!"
365 fi
366
367 # Now that we know we're actually going to apply something, merge
368 # all of the patch options back in to a single variable for below.
369 EPATCH_OPTS="${EPATCH_COMMON_OPTS} ${EPATCH_OPTS[*]}"
370
371 local PIPE_CMD
372 case ${EPATCH_SUFFIX##*\.} in
373 xz) PIPE_CMD="xz -dc" ;;
374 lzma) PIPE_CMD="lzma -dc" ;;
375 bz2) PIPE_CMD="bzip2 -dc" ;;
376 gz|Z|z) PIPE_CMD="gzip -dc" ;;
377 ZIP|zip) PIPE_CMD="unzip -p" ;;
378 *) ;;
379 esac
380
381 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
382
383 local x
384 for x in "$@" ; do
385 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
386 # didn't match anything, ignore continue on
387 [[ ! -f ${x} ]] && continue
388
389 local patchname=${x##*/}
390
391 # Apply single patches, or forced sets of patches, or
392 # patches with ARCH dependant names.
393 # ???_arch_foo.patch
394 # Else, skip this input altogether
395 local a=${patchname#*_} # strip the ???_
396 a=${a%%_*} # strip the _foo.patch
397 if ! [[ ${SINGLE_PATCH} == "yes" || \
398 ${EPATCH_FORCE} == "yes" || \
399 ${a} == all || \
400 ${a} == ${ARCH} ]]
163 then 401 then
164 local EPATCH_SOURCE="$1/*" 402 continue
403 fi
404
405 # Let people filter things dynamically
406 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
407 # let people use globs in the exclude
408 eshopts_push -o noglob
409
410 local ex
411 for ex in ${EPATCH_EXCLUDE} ; do
412 if [[ ${patchname} == ${ex} ]] ; then
413 einfo " Skipping ${patchname} due to EPATCH_EXCLUDE ..."
414 eshopts_pop
415 continue 2
416 fi
417 done
418
419 for ex in ${EPATCH_USER_EXCLUDE} ; do
420 if [[ ${patchname} == ${ex} ]] ; then
421 einfo " Skipping ${patchname} due to EPATCH_USER_EXCLUDE ..."
422 eshopts_pop
423 continue 2
424 fi
425 done
426
427 eshopts_pop
428 fi
429
430 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
431 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
432 einfo "${EPATCH_SINGLE_MSG}"
433 else
434 einfo "Applying ${patchname} ..."
435 fi
165 else 436 else
166 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 437 einfo " ${patchname} ..."
167 fi 438 fi
168 else 439
169 if [[ ! -d ${EPATCH_SOURCE} ]] || [[ -n $1 ]] ; then 440 # most of the time, there will only be one run per unique name,
170 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 441 # but if there are more, make sure we get unique log filenames
171 then 442 local STDERR_TARGET="${T}/${patchname}.out"
172 EPATCH_SOURCE="$1" 443 if [[ -e ${STDERR_TARGET} ]] ; then
444 STDERR_TARGET="${T}/${patchname}-$$.out"
445 fi
446
447 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
448
449 # Decompress the patch if need be
450 local count=0
451 local PATCH_TARGET
452 if [[ -n ${PIPE_CMD} ]] ; then
453 PATCH_TARGET="${T}/$$.patch"
454 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
455
456 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
457 echo
458 eerror "Could not extract patch!"
459 #die "Could not extract patch!"
460 count=5
461 break
173 fi 462 fi
463 else
464 PATCH_TARGET=${x}
465 fi
174 466
467 # Check for absolute paths in patches. If sandbox is disabled,
468 # people could (accidently) patch files in the root filesystem.
469 # Or trigger other unpleasantries #237667. So disallow -p0 on
470 # such patches.
471 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
472 if [[ -n ${abs_paths} ]] ; then
473 count=1
474 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
475 fi
476 # Similar reason, but with relative paths.
477 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
478 if [[ -n ${rel_paths} ]] ; then
175 echo 479 echo
176 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 480 eerror "Rejected Patch: ${patchname} !"
481 eerror " ( ${PATCH_TARGET} )"
177 eerror 482 eerror
178 eerror " ${EPATCH_SOURCE}" 483 eerror "Your patch uses relative paths '../':"
179 eerror " ( ${EPATCH_SOURCE##*/} )" 484 eerror "${rel_paths}"
180 echo 485 echo
181 die "Cannot find \$EPATCH_SOURCE!" 486 die "you need to fix the relative paths in patch"
182 fi
183
184 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
185 fi 487 fi
186 488
187 case ${EPATCH_SUFFIX##*\.} in 489 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
188 bz2) 490 local patch_cmd
189 PIPE_CMD="bzip2 -dc" 491 # Handle aliased patch command #404447 #461568
190 PATCH_SUFFIX="bz2" 492 local patch="patch"
191 ;; 493 eval $(alias patch 2>/dev/null | sed 's:^alias ::')
192 gz|Z|z) 494 while [[ ${count} -lt 5 ]] ; do
193 PIPE_CMD="gzip -dc" 495 patch_cmd="${patch} -p${count} ${EPATCH_OPTS}"
194 PATCH_SUFFIX="gz"
195 ;;
196 ZIP|zip)
197 PIPE_CMD="unzip -p"
198 PATCH_SUFFIX="zip"
199 ;;
200 *)
201 PIPE_CMD="cat"
202 PATCH_SUFFIX="patch"
203 ;;
204 esac
205 496
206 if [ "${SINGLE_PATCH}" = "no" ] 497 # Generate some useful debug info ...
207 then 498 (
208 einfo "${EPATCH_MULTI_MSG}" 499 _epatch_draw_line "***** ${patchname} *****"
209 fi 500 echo
210 for x in ${EPATCH_SOURCE} 501 echo "PATCH COMMAND: ${patch_cmd} < '${PATCH_TARGET}'"
211 do 502 echo
212 # New ARCH dependant patch naming scheme ... 503 _epatch_draw_line "***** ${patchname} *****"
213 # 504 ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
214 # ???_arch_foo.patch 505 ret=$?
215 # 506 echo
216 if [ -f ${x} ] && \ 507 echo "patch program exited with status ${ret}"
217 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \ 508 exit ${ret}
218 [ "${EPATCH_FORCE}" = "yes" ]) 509 ) >> "${STDERR_TARGET}"
219 then
220 local count=0
221 local popts="${EPATCH_OPTS}"
222 local patchname=${x##*/}
223 510
224 if [ -n "${EPATCH_EXCLUDE}" ] 511 if [ $? -eq 0 ] ; then
225 then 512 (
226 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ] 513 _epatch_draw_line "***** ${patchname} *****"
227 then 514 echo
228 continue 515 echo "ACTUALLY APPLYING ${patchname} ..."
516 echo
517 _epatch_draw_line "***** ${patchname} *****"
518 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
519 ret=$?
520 echo
521 echo "patch program exited with status ${ret}"
522 exit ${ret}
523 ) >> "${STDERR_TARGET}"
524
525 if [ $? -ne 0 ] ; then
526 echo
527 eerror "A dry-run of patch command succeeded, but actually"
528 eerror "applying the patch failed!"
529 #die "Real world sux compared to the dreamworld!"
530 count=5
229 fi 531 fi
532 break
230 fi 533 fi
231 534
232 if [ "${SINGLE_PATCH}" = "yes" ] 535 : $(( count++ ))
233 then
234 if [ -n "${EPATCH_SINGLE_MSG}" ]
235 then
236 einfo "${EPATCH_SINGLE_MSG}"
237 else
238 einfo "Applying ${patchname} ..."
239 fi
240 else
241 einfo " ${patchname} ..."
242 fi
243
244 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
245 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
246
247 # Allow for prefix to differ ... im lazy, so shoot me :/
248 while [ "${count}" -lt 5 ]
249 do
250 # Generate some useful debug info ...
251 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
252 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
253
254 if [ "${PATCH_SUFFIX}" != "patch" ]
255 then
256 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
257 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
258 else
259 PATCH_TARGET="${x}"
260 fi
261
262 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
263 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
264
265 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
266 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
267
268 if [ "${PATCH_SUFFIX}" != "patch" ]
269 then
270 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
271 then
272 echo
273 eerror "Could not extract patch!"
274 #die "Could not extract patch!"
275 count=5
276 break
277 fi
278 fi
279
280 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
281 then
282 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
283 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
284 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
285 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
286 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
287
288 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
289 _epatch_assert
290
291 if [ "$?" -ne 0 ]
292 then
293 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
294 echo
295 eerror "A dry-run of patch command succeeded, but actually"
296 eerror "applying the patch failed!"
297 #die "Real world sux compared to the dreamworld!"
298 count=5
299 fi
300
301 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
302
303 break
304 fi
305
306 count=$((count + 1))
307 done 536 done
308 537
309 if [ "${PATCH_SUFFIX}" != "patch" ] 538 # if we had to decompress the patch, delete the temp one
310 then 539 if [[ -n ${PIPE_CMD} ]] ; then
311 rm -f ${PATCH_TARGET} 540 rm -f "${PATCH_TARGET}"
312 fi 541 fi
313 542
314 if [ "${count}" -eq 5 ] 543 if [[ ${count} -ge 5 ]] ; then
315 then
316 echo 544 echo
317 eerror "Failed Patch: ${patchname} !" 545 eerror "Failed Patch: ${patchname} !"
318 eerror " ( ${PATCH_TARGET} )" 546 eerror " ( ${PATCH_TARGET} )"
319 eerror 547 eerror
320 eerror "Include in your bugreport the contents of:" 548 eerror "Include in your bugreport the contents of:"
321 eerror 549 eerror
322 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}" 550 eerror " ${STDERR_TARGET}"
323 echo 551 echo
324 die "Failed Patch: ${patchname}!" 552 die "Failed Patch: ${patchname}!"
325 fi 553 fi
326 554
327 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 555 # if everything worked, delete the full debug patch log
556 rm -f "${STDERR_TARGET}"
328 557
558 # then log away the exact stuff for people to review later
559 cat <<-EOF >> "${T}/epatch.log"
560 PATCH: ${x}
561 CMD: ${patch_cmd}
562 PWD: ${PWD}
563
564 EOF
329 eend 0 565 eend 0
330 fi
331 done 566 done
332 if [ "${SINGLE_PATCH}" = "no" ] 567
333 then 568 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
334 einfo "Done with patching" 569 : # everything worked
570}
571
572# @FUNCTION: epatch_user
573# @USAGE:
574# @DESCRIPTION:
575# Applies user-provided patches to the source tree. The patches are
576# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>[:SLOT]/, where the first
577# of these three directories to exist will be the one to use, ignoring
578# any more general directories which might exist as well. They must end
579# in ".patch" to be applied.
580#
581# User patches are intended for quick testing of patches without ebuild
582# modifications, as well as for permanent customizations a user might
583# desire. Obviously, there can be no official support for arbitrarily
584# patched ebuilds. So whenever a build log in a bug report mentions that
585# user patches were applied, the user should be asked to reproduce the
586# problem without these.
587#
588# Not all ebuilds do call this function, so placing patches in the
589# stated directory might or might not work, depending on the package and
590# the eclasses it inherits and uses. It is safe to call the function
591# repeatedly, so it is always possible to add a call at the ebuild
592# level. The first call is the time when the patches will be
593# applied.
594#
595# Ideally, this function should be called after gentoo-specific patches
596# have been applied, so that their code can be modified as well, but
597# before calls to e.g. eautoreconf, as the user patches might affect
598# autotool input files as well.
599epatch_user() {
600 [[ $# -ne 0 ]] && die "epatch_user takes no options"
601
602 # Allow multiple calls to this function; ignore all but the first
603 local applied="${T}/epatch_user.log"
604 [[ -e ${applied} ]] && return 2
605
606 # don't clobber any EPATCH vars that the parent might want
607 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
608 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}{,:${SLOT}}; do
609 EPATCH_SOURCE=${base}/${CTARGET}/${check}
610 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
611 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
612 if [[ -d ${EPATCH_SOURCE} ]] ; then
613 EPATCH_SOURCE=${EPATCH_SOURCE} \
614 EPATCH_SUFFIX="patch" \
615 EPATCH_FORCE="yes" \
616 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
617 epatch
618 echo "${EPATCH_SOURCE}" > "${applied}"
619 return 0
335 fi 620 fi
621 done
622 echo "none" > "${applied}"
623 return 1
336} 624}
337 625
338# @FUNCTION: emktemp 626# @FUNCTION: emktemp
339# @USAGE: [temp dir] 627# @USAGE: [temp dir]
340# @DESCRIPTION: 628# @DESCRIPTION:
368 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX 656 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
369 fi 657 fi
370 fi 658 fi
371} 659}
372 660
373# @FUNCTION: egetent
374# @USAGE: <database> <key>
375# @MAINTAINER:
376# base-system@gentoo.org (Linux)
377# Joe Jezak <josejx@gmail.com> (OS X)
378# usata@gentoo.org (OS X)
379# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
380# @DESCRIPTION:
381# Small wrapper for getent (Linux), nidump (Mac OS X),
382# and pw (FreeBSD) used in enewuser()/enewgroup()
383egetent() {
384 case ${CHOST} in
385 *-darwin*)
386 case "$2" in
387 *[!0-9]*) # Non numeric
388 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
389 ;;
390 *) # Numeric
391 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
392 ;;
393 esac
394 ;;
395 *-freebsd*|*-dragonfly*)
396 local opts action="user"
397 [[ $1 == "passwd" ]] || action="group"
398
399 # lookup by uid/gid
400 if [[ $2 == [[:digit:]]* ]] ; then
401 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
402 fi
403
404 pw show ${action} ${opts} "$2" -q
405 ;;
406 *-netbsd*|*-openbsd*)
407 grep "$2:\*:" /etc/$1
408 ;;
409 *)
410 type -p nscd >& /dev/null && nscd -i "$1"
411 getent "$1" "$2"
412 ;;
413 esac
414}
415
416# @FUNCTION: enewuser
417# @USAGE: <user> [uid] [shell] [homedir] [groups] [params]
418# @DESCRIPTION:
419# Same as enewgroup, you are not required to understand how to properly add
420# a user to the system. The only required parameter is the username.
421# Default uid is (pass -1 for this) next available, default shell is
422# /bin/false, default homedir is /dev/null, there are no default groups,
423# and default params sets the comment as 'added by portage for ${PN}'.
424enewuser() {
425 case ${EBUILD_PHASE} in
426 unpack|compile|test|install)
427 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
428 eerror "Package fails at QA and at life. Please file a bug."
429 die "Bad package! enewuser is only for use in pkg_* functions!"
430 esac
431
432 # get the username
433 local euser=$1; shift
434 if [[ -z ${euser} ]] ; then
435 eerror "No username specified !"
436 die "Cannot call enewuser without a username"
437 fi
438
439 # lets see if the username already exists
440 if [[ -n $(egetent passwd "${euser}") ]] ; then
441 return 0
442 fi
443 einfo "Adding user '${euser}' to your system ..."
444
445 # options to pass to useradd
446 local opts=
447
448 # handle uid
449 local euid=$1; shift
450 if [[ -n ${euid} && ${euid} != -1 ]] ; then
451 if [[ ${euid} -gt 0 ]] ; then
452 if [[ -n $(egetent passwd ${euid}) ]] ; then
453 euid="next"
454 fi
455 else
456 eerror "Userid given but is not greater than 0 !"
457 die "${euid} is not a valid UID"
458 fi
459 else
460 euid="next"
461 fi
462 if [[ ${euid} == "next" ]] ; then
463 for ((euid = 101; euid <= 999; euid++)); do
464 [[ -z $(egetent passwd ${euid}) ]] && break
465 done
466 fi
467 opts="${opts} -u ${euid}"
468 einfo " - Userid: ${euid}"
469
470 # handle shell
471 local eshell=$1; shift
472 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
473 if [[ ! -e ${ROOT}${eshell} ]] ; then
474 eerror "A shell was specified but it does not exist !"
475 die "${eshell} does not exist in ${ROOT}"
476 fi
477 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
478 eerror "Do not specify ${eshell} yourself, use -1"
479 die "Pass '-1' as the shell parameter"
480 fi
481 else
482 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
483 [[ -x ${ROOT}${shell} ]] && break
484 done
485
486 if [[ ${shell} == "/dev/null" ]] ; then
487 eerror "Unable to identify the shell to use, proceeding with userland default."
488 case ${USERLAND} in
489 GNU) shell="/bin/false" ;;
490 BSD) shell="/sbin/nologin" ;;
491 Darwin) shell="/usr/sbin/nologin" ;;
492 *) die "Unable to identify the default shell for userland ${USERLAND}"
493 esac
494 fi
495
496 eshell=${shell}
497 fi
498 einfo " - Shell: ${eshell}"
499 opts="${opts} -s ${eshell}"
500
501 # handle homedir
502 local ehome=$1; shift
503 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
504 ehome="/dev/null"
505 fi
506 einfo " - Home: ${ehome}"
507 opts="${opts} -d ${ehome}"
508
509 # handle groups
510 local egroups=$1; shift
511 if [[ ! -z ${egroups} ]] ; then
512 local oldifs=${IFS}
513 local defgroup="" exgroups=""
514
515 export IFS=","
516 for g in ${egroups} ; do
517 export IFS=${oldifs}
518 if [[ -z $(egetent group "${g}") ]] ; then
519 eerror "You must add group ${g} to the system first"
520 die "${g} is not a valid GID"
521 fi
522 if [[ -z ${defgroup} ]] ; then
523 defgroup=${g}
524 else
525 exgroups="${exgroups},${g}"
526 fi
527 export IFS=","
528 done
529 export IFS=${oldifs}
530
531 opts="${opts} -g ${defgroup}"
532 if [[ ! -z ${exgroups} ]] ; then
533 opts="${opts} -G ${exgroups:1}"
534 fi
535 else
536 egroups="(none)"
537 fi
538 einfo " - Groups: ${egroups}"
539
540 # handle extra and add the user
541 local oldsandbox=${SANDBOX_ON}
542 export SANDBOX_ON="0"
543 case ${CHOST} in
544 *-darwin*)
545 ### Make the user
546 if [[ -z $@ ]] ; then
547 dscl . create /users/${euser} uid ${euid}
548 dscl . create /users/${euser} shell ${eshell}
549 dscl . create /users/${euser} home ${ehome}
550 dscl . create /users/${euser} realname "added by portage for ${PN}"
551 ### Add the user to the groups specified
552 local oldifs=${IFS}
553 export IFS=","
554 for g in ${egroups} ; do
555 dscl . merge /groups/${g} users ${euser}
556 done
557 export IFS=${oldifs}
558 else
559 einfo "Extra options are not supported on Darwin yet"
560 einfo "Please report the ebuild along with the info below"
561 einfo "eextra: $@"
562 die "Required function missing"
563 fi
564 ;;
565 *-freebsd*|*-dragonfly*)
566 if [[ -z $@ ]] ; then
567 pw useradd ${euser} ${opts} \
568 -c "added by portage for ${PN}" \
569 die "enewuser failed"
570 else
571 einfo " - Extra: $@"
572 pw useradd ${euser} ${opts} \
573 "$@" || die "enewuser failed"
574 fi
575 ;;
576
577 *-netbsd*)
578 if [[ -z $@ ]] ; then
579 useradd ${opts} ${euser} || die "enewuser failed"
580 else
581 einfo " - Extra: $@"
582 useradd ${opts} ${euser} "$@" || die "enewuser failed"
583 fi
584 ;;
585
586 *-openbsd*)
587 if [[ -z $@ ]] ; then
588 useradd -u ${euid} -s ${eshell} \
589 -d ${ehome} -c "Added by portage for ${PN}" \
590 -g ${egroups} ${euser} || die "enewuser failed"
591 else
592 einfo " - Extra: $@"
593 useradd -u ${euid} -s ${eshell} \
594 -d ${ehome} -c "Added by portage for ${PN}" \
595 -g ${egroups} ${euser} "$@" || die "enewuser failed"
596 fi
597 ;;
598
599 *)
600 if [[ -z $@ ]] ; then
601 useradd ${opts} ${euser} \
602 -c "added by portage for ${PN}" \
603 || die "enewuser failed"
604 else
605 einfo " - Extra: $@"
606 useradd ${opts} ${euser} "$@" \
607 || die "enewuser failed"
608 fi
609 ;;
610 esac
611
612 if [[ ! -e ${ROOT}/${ehome} ]] ; then
613 einfo " - Creating ${ehome} in ${ROOT}"
614 mkdir -p "${ROOT}/${ehome}"
615 chown ${euser} "${ROOT}/${ehome}"
616 chmod 755 "${ROOT}/${ehome}"
617 fi
618
619 export SANDBOX_ON=${oldsandbox}
620}
621
622# @FUNCTION: enewgroup
623# @USAGE: <group> [gid]
624# @DESCRIPTION:
625# This function does not require you to understand how to properly add a
626# group to the system. Just give it a group name to add and enewgroup will
627# do the rest. You may specify the gid for the group or allow the group to
628# allocate the next available one.
629enewgroup() {
630 case ${EBUILD_PHASE} in
631 unpack|compile|test|install)
632 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
633 eerror "Package fails at QA and at life. Please file a bug."
634 die "Bad package! enewgroup is only for use in pkg_* functions!"
635 esac
636
637 # get the group
638 local egroup="$1"; shift
639 if [ -z "${egroup}" ]
640 then
641 eerror "No group specified !"
642 die "Cannot call enewgroup without a group"
643 fi
644
645 # see if group already exists
646 if [[ -n $(egetent group "${egroup}") ]]; then
647 return 0
648 fi
649 einfo "Adding group '${egroup}' to your system ..."
650
651 # options to pass to useradd
652 local opts=
653
654 # handle gid
655 local egid="$1"; shift
656 if [ ! -z "${egid}" ]
657 then
658 if [ "${egid}" -gt 0 ]
659 then
660 if [ -z "`egetent group ${egid}`" ]
661 then
662 if [[ "${CHOST}" == *-darwin* ]]; then
663 opts="${opts} ${egid}"
664 else
665 opts="${opts} -g ${egid}"
666 fi
667 else
668 egid="next available; requested gid taken"
669 fi
670 else
671 eerror "Groupid given but is not greater than 0 !"
672 die "${egid} is not a valid GID"
673 fi
674 else
675 egid="next available"
676 fi
677 einfo " - Groupid: ${egid}"
678
679 # handle extra
680 local eextra="$@"
681 opts="${opts} ${eextra}"
682
683 # add the group
684 local oldsandbox="${SANDBOX_ON}"
685 export SANDBOX_ON="0"
686 case ${CHOST} in
687 *-darwin*)
688 if [ ! -z "${eextra}" ];
689 then
690 einfo "Extra options are not supported on Darwin/OS X yet"
691 einfo "Please report the ebuild along with the info below"
692 einfo "eextra: ${eextra}"
693 die "Required function missing"
694 fi
695
696 # If we need the next available
697 case ${egid} in
698 *[!0-9]*) # Non numeric
699 for ((egid = 101; egid <= 999; egid++)); do
700 [[ -z $(egetent group ${egid}) ]] && break
701 done
702 esac
703 dscl . create /groups/${egroup} gid ${egid}
704 dscl . create /groups/${egroup} passwd '*'
705 ;;
706
707 *-freebsd*|*-dragonfly*)
708 case ${egid} in
709 *[!0-9]*) # Non numeric
710 for ((egid = 101; egid <= 999; egid++)); do
711 [[ -z $(egetent group ${egid}) ]] && break
712 done
713 esac
714 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
715 ;;
716
717 *-netbsd*)
718 case ${egid} in
719 *[!0-9]*) # Non numeric
720 for ((egid = 101; egid <= 999; egid++)); do
721 [[ -z $(egetent group ${egid}) ]] && break
722 done
723 esac
724 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
725 ;;
726
727 *)
728 groupadd ${opts} ${egroup} || die "enewgroup failed"
729 ;;
730 esac
731 export SANDBOX_ON="${oldsandbox}"
732}
733
734# @FUNCTION: edos2unix 661# @FUNCTION: edos2unix
735# @USAGE: <file> [more files ...] 662# @USAGE: <file> [more files ...]
736# @DESCRIPTION: 663# @DESCRIPTION:
737# A handy replacement for dos2unix, recode, fixdos, etc... This allows you 664# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
738# to remove all of these text utilities from DEPEND variables because this 665# to remove all of these text utilities from DEPEND variables because this
739# is a script based solution. Just give it a list of files to convert and 666# is a script based solution. Just give it a list of files to convert and
740# they will all be changed from the DOS CRLF format to the UNIX LF format. 667# they will all be changed from the DOS CRLF format to the UNIX LF format.
741edos2unix() { 668edos2unix() {
742 echo "$@" | xargs sed -i 's/\r$//' 669 [[ $# -eq 0 ]] && return 0
670 sed -i 's/\r$//' -- "$@" || die
743} 671}
744 672
673# @FUNCTION: make_desktop_entry
674# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
675# @DESCRIPTION:
745# Make a desktop file ! 676# Make a .desktop file.
746# Great for making those icons in kde/gnome startmenu !
747# Amaze your friends ! Get the women ! Join today !
748# 677#
749# make_desktop_entry(<command>, [name], [icon], [type], [path]) 678# @CODE
750#
751# binary: what command does the app run with ? 679# binary: what command does the app run with ?
752# name: the name that will show up in the menu 680# name: the name that will show up in the menu
753# icon: give your little like a pretty little icon ... 681# icon: the icon to use in the menu entry
754# this can be relative (to /usr/share/pixmaps) or 682# this can be relative (to /usr/share/pixmaps) or
755# a full path to an icon 683# a full path to an icon
756# type: what kind of application is this ? for categories: 684# type: what kind of application is this?
685# for categories:
757# http://standards.freedesktop.org/menu-spec/latest/apa.html 686# http://standards.freedesktop.org/menu-spec/latest/apa.html
758# path: if your app needs to startup in a specific dir 687# if unset, function tries to guess from package's category
688# fields: extra fields to append to the desktop file; a printf string
689# @CODE
759make_desktop_entry() { 690make_desktop_entry() {
760 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 691 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
761 692
762 local exec=${1} 693 local exec=${1}
763 local name=${2:-${PN}} 694 local name=${2:-${PN}}
764 local icon=${3:-${PN}} 695 local icon=${3:-${PN}}
765 local type=${4} 696 local type=${4}
766 local path=${5} 697 local fields=${5}
767 698
768 if [[ -z ${type} ]] ; then 699 if [[ -z ${type} ]] ; then
769 local catmaj=${CATEGORY%%-*} 700 local catmaj=${CATEGORY%%-*}
770 local catmin=${CATEGORY##*-} 701 local catmin=${CATEGORY##*-}
771 case ${catmaj} in 702 case ${catmaj} in
772 app) 703 app)
773 case ${catmin} in 704 case ${catmin} in
774 accessibility) type=Accessibility;; 705 accessibility) type="Utility;Accessibility";;
775 admin) type=System;; 706 admin) type=System;;
776 antivirus) type=System;; 707 antivirus) type=System;;
777 arch) type=Archiving;; 708 arch) type="Utility;Archiving";;
778 backup) type=Archiving;; 709 backup) type="Utility;Archiving";;
779 cdr) type=DiscBurning;; 710 cdr) type="AudioVideo;DiscBurning";;
780 dicts) type=Dictionary;; 711 dicts) type="Office;Dictionary";;
781 doc) type=Documentation;; 712 doc) type=Documentation;;
782 editors) type=TextEditor;; 713 editors) type="Utility;TextEditor";;
783 emacs) type=TextEditor;; 714 emacs) type="Development;TextEditor";;
784 emulation) type=Emulator;; 715 emulation) type="System;Emulator";;
785 laptop) type=HardwareSettings;; 716 laptop) type="Settings;HardwareSettings";;
786 office) type=Office;; 717 office) type=Office;;
787 pda) type=PDA;; 718 pda) type="Office;PDA";;
788 vim) type=TextEditor;; 719 vim) type="Development;TextEditor";;
789 xemacs) type=TextEditor;; 720 xemacs) type="Development;TextEditor";;
790 *) type=;;
791 esac 721 esac
792 ;; 722 ;;
793 723
794 dev) 724 dev)
795 type="Development" 725 type="Development"
796 ;; 726 ;;
797 727
798 games) 728 games)
799 case ${catmin} in 729 case ${catmin} in
800 action|fps) type=ActionGame;; 730 action|fps) type=ActionGame;;
801 arcade) type=ArcadeGame;; 731 arcade) type=ArcadeGame;;
802 board) type=BoardGame;; 732 board) type=BoardGame;;
803 emulation) type=Emulator;; 733 emulation) type=Emulator;;
804 kids) type=KidsGame;; 734 kids) type=KidsGame;;
805 puzzle) type=LogicGame;; 735 puzzle) type=LogicGame;;
806 roguelike) type=RolePlaying;; 736 roguelike) type=RolePlaying;;
807 rpg) type=RolePlaying;; 737 rpg) type=RolePlaying;;
808 simulation) type=Simulation;; 738 simulation) type=Simulation;;
809 sports) type=SportsGame;; 739 sports) type=SportsGame;;
810 strategy) type=StrategyGame;; 740 strategy) type=StrategyGame;;
811 *) type=;;
812 esac 741 esac
813 type="Game;${type}" 742 type="Game;${type}"
814 ;; 743 ;;
815 744
816 gnome) 745 gnome)
825 type="Network;Email" 754 type="Network;Email"
826 ;; 755 ;;
827 756
828 media) 757 media)
829 case ${catmin} in 758 case ${catmin} in
759 gfx)
830 gfx) type=Graphics;; 760 type=Graphics
761 ;;
762 *)
763 case ${catmin} in
831 radio) type=Tuner;; 764 radio) type=Tuner;;
832 sound) type=Audio;; 765 sound) type=Audio;;
833 tv) type=TV;; 766 tv) type=TV;;
834 video) type=Video;; 767 video) type=Video;;
835 *) type=;; 768 esac
769 type="AudioVideo;${type}"
770 ;;
836 esac 771 esac
837 type="AudioVideo;${type}"
838 ;; 772 ;;
839 773
840 net) 774 net)
841 case ${catmin} in 775 case ${catmin} in
842 dialup) type=Dialup;; 776 dialup) type=Dialup;;
843 ftp) type=FileTransfer;; 777 ftp) type=FileTransfer;;
844 im) type=InstantMessaging;; 778 im) type=InstantMessaging;;
845 irc) type=IRCClient;; 779 irc) type=IRCClient;;
846 mail) type=Email;; 780 mail) type=Email;;
847 news) type=News;; 781 news) type=News;;
848 nntp) type=News;; 782 nntp) type=News;;
849 p2p) type=FileTransfer;; 783 p2p) type=FileTransfer;;
850 *) type=;; 784 voip) type=Telephony;;
851 esac 785 esac
852 type="Network;${type}" 786 type="Network;${type}"
853 ;; 787 ;;
854 788
855 sci) 789 sci)
856 case ${catmin} in 790 case ${catmin} in
857 astro*) type=Astronomy;; 791 astro*) type=Astronomy;;
858 bio*) type=Biology;; 792 bio*) type=Biology;;
859 calc*) type=Calculator;; 793 calc*) type=Calculator;;
860 chem*) type=Chemistry;; 794 chem*) type=Chemistry;;
861 elec*) type=Electronics;; 795 elec*) type=Electronics;;
862 geo*) type=Geology;; 796 geo*) type=Geology;;
863 math*) type=Math;; 797 math*) type=Math;;
864 physics) type=Physics;; 798 physics) type=Physics;;
865 visual*) type=DataVisualization;; 799 visual*) type=DataVisualization;;
866 *) type=;;
867 esac 800 esac
868 type="Science;${type}" 801 type="Education;Science;${type}"
869 ;; 802 ;;
870 803
871 sys) 804 sys)
872 type="System" 805 type="System"
873 ;; 806 ;;
874 807
875 www) 808 www)
876 case ${catmin} in 809 case ${catmin} in
877 client) type=WebBrowser;; 810 client) type=WebBrowser;;
878 *) type=;;
879 esac 811 esac
880 type="Network" 812 type="Network;${type}"
881 ;; 813 ;;
882 814
883 *) 815 *)
884 type= 816 type=
885 ;; 817 ;;
891 local desktop_name="${PN}-${SLOT}" 823 local desktop_name="${PN}-${SLOT}"
892 fi 824 fi
893 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop" 825 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
894 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 826 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
895 827
828 # Don't append another ";" when a valid category value is provided.
829 type=${type%;}${type:+;}
830
831 eshopts_push -s extglob
832 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
833 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
834 ewarn "allowed in .desktop files if the value is not an absolute path."
835 icon=${icon%.@(xpm|png|svg)}
836 fi
837 eshopts_pop
838
896 cat <<-EOF > "${desktop}" 839 cat <<-EOF > "${desktop}"
897 [Desktop Entry] 840 [Desktop Entry]
898 Version=1.0
899 Name=${name} 841 Name=${name}
900 Type=Application 842 Type=Application
901 Comment=${DESCRIPTION} 843 Comment=${DESCRIPTION}
902 Exec=${exec} 844 Exec=${exec}
903 TryExec=${exec%% *} 845 TryExec=${exec%% *}
904 Icon=${icon} 846 Icon=${icon}
905 Categories=${type}; 847 Categories=${type}
906 EOF 848 EOF
907 849
908 [[ ${path} ]] && echo "Path=${path}" >> "${desktop}" 850 if [[ ${fields:-=} != *=* ]] ; then
851 # 5th arg used to be value to Path=
852 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
853 fields="Path=${fields}"
854 fi
855 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
909 856
910 ( 857 (
911 # wrap the env here so that the 'insinto' call 858 # wrap the env here so that the 'insinto' call
912 # doesn't corrupt the env of the caller 859 # doesn't corrupt the env of the caller
913 insinto /usr/share/applications 860 insinto /usr/share/applications
914 doins "${desktop}" 861 doins "${desktop}"
915 ) 862 ) || die "installing desktop file failed"
916} 863}
917 864
918# @FUNCTION: validate_desktop_entries 865# @FUNCTION: validate_desktop_entries
919# @USAGE: [directories] 866# @USAGE: [directories]
920# @MAINTAINER: 867# @MAINTAINER:
942 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo." 889 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
943 fi 890 fi
944} 891}
945 892
946# @FUNCTION: make_session_desktop 893# @FUNCTION: make_session_desktop
947# @USAGE: <title> <command> 894# @USAGE: <title> <command> [command args...]
948# @DESCRIPTION: 895# @DESCRIPTION:
949# Make a GDM/KDM Session file. The title is the file to execute to start the 896# Make a GDM/KDM Session file. The title is the file to execute to start the
950# Window Manager. The command is the name of the Window Manager. 897# Window Manager. The command is the name of the Window Manager.
898#
899# You can set the name of the file via the ${wm} variable.
951make_session_desktop() { 900make_session_desktop() {
952 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 901 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
953 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 902 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
954 903
955 local title=$1 904 local title=$1
956 local command=$2 905 local command=$2
957 local desktop=${T}/${wm}.desktop 906 local desktop=${T}/${wm:-${PN}}.desktop
907 shift 2
958 908
959 cat <<-EOF > "${desktop}" 909 cat <<-EOF > "${desktop}"
960 [Desktop Entry] 910 [Desktop Entry]
961 Name=${title} 911 Name=${title}
962 Comment=This session logs you into ${title} 912 Comment=This session logs you into ${title}
963 Exec=${command} 913 Exec=${command} $*
964 TryExec=${command} 914 TryExec=${command}
965 Type=Application 915 Type=XSession
966 EOF 916 EOF
967 917
968 ( 918 (
969 # wrap the env here so that the 'insinto' call 919 # wrap the env here so that the 'insinto' call
970 # doesn't corrupt the env of the caller 920 # doesn't corrupt the env of the caller
1012 insinto /usr/share/applications 962 insinto /usr/share/applications
1013 newins "$@" 963 newins "$@"
1014 ) 964 )
1015} 965}
1016 966
1017# @FUNCTION: doicon 967# @FUNCTION: _iconins
1018# @USAGE: <list of icons> 968# @INTERNAL
1019# @DESCRIPTION: 969# @DESCRIPTION:
1020# Install the list of icons into the icon directory (/usr/share/pixmaps). 970# function for use in doicon and newicon
1021# This is useful in conjunction with creating desktop/menu files. 971_iconins() {
1022doicon() {
1023 ( 972 (
1024 # wrap the env here so that the 'insinto' call 973 # wrap the env here so that the 'insinto' call
1025 # doesn't corrupt the env of the caller 974 # doesn't corrupt the env of the caller
1026 local i j ret 975 local funcname=$1; shift
1027 insinto /usr/share/pixmaps 976 local size dir
1028 for i in "$@" ; do 977 local context=apps
1029 if [[ -f ${i} ]] ; then 978 local theme=hicolor
1030 doins "${i}" 979
1031 ((ret+=$?)) 980 while [[ $# -gt 0 ]] ; do
1032 elif [[ -d ${i} ]] ; then 981 case $1 in
1033 for j in "${i}"/*.png ; do 982 -s|--size)
1034 doins "${j}" 983 if [[ ${2%%x*}x${2%%x*} == "$2" ]] ; then
1035 ((ret+=$?)) 984 size=${2%%x*}
1036 done
1037 else 985 else
1038 ((++ret)) 986 size=${2}
1039 fi 987 fi
1040 done
1041 exit ${ret}
1042 )
1043}
1044
1045# @FUNCTION: newicon
1046# @USAGE: <icon> <newname>
1047# @DESCRIPTION:
1048# Like all other new* functions, install the specified icon as newname.
1049newicon() {
1050 (
1051 # wrap the env here so that the 'insinto' call
1052 # doesn't corrupt the env of the caller
1053 insinto /usr/share/pixmaps
1054 newins "$@"
1055 )
1056}
1057
1058# for internal use only (unpack_pdv and unpack_makeself)
1059find_unpackable_file() {
1060 local src=$1
1061 if [[ -z ${src} ]] ; then
1062 src=${DISTDIR}/${A}
1063 else
1064 if [[ -e ${DISTDIR}/${src} ]] ; then
1065 src=${DISTDIR}/${src}
1066 elif [[ -e ${PWD}/${src} ]] ; then
1067 src=${PWD}/${src}
1068 elif [[ -e ${src} ]] ; then
1069 src=${src}
1070 fi
1071 fi
1072 [[ ! -e ${src} ]] && return 1
1073 echo "${src}"
1074}
1075
1076# @FUNCTION: unpack_pdv
1077# @USAGE: <file to unpack> <size of off_t>
1078# @DESCRIPTION:
1079# Unpack those pesky pdv generated files ...
1080# They're self-unpacking programs with the binary package stuffed in
1081# the middle of the archive. Valve seems to use it a lot ... too bad
1082# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1083#
1084# You have to specify the off_t size ... I have no idea how to extract that
1085# information out of the binary executable myself. Basically you pass in
1086# the size of the off_t type (in bytes) on the machine that built the pdv
1087# archive.
1088#
1089# One way to determine this is by running the following commands:
1090#
1091# @CODE
1092# strings <pdv archive> | grep lseek
1093# strace -elseek <pdv archive>
1094# @CODE
1095#
1096# Basically look for the first lseek command (we do the strings/grep because
1097# sometimes the function call is _llseek or something) and steal the 2nd
1098# parameter. Here is an example:
1099#
1100# @CODE
1101# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1102# lseek
1103# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1104# lseek(3, -4, SEEK_END) = 2981250
1105# @CODE
1106#
1107# Thus we would pass in the value of '4' as the second parameter.
1108unpack_pdv() {
1109 local src=$(find_unpackable_file "$1")
1110 local sizeoff_t=$2
1111
1112 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1113 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1114
1115 local shrtsrc=$(basename "${src}")
1116 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1117 local metaskip=$(tail -c ${sizeoff_t} "${src}" | hexdump -e \"%i\")
1118 local tailskip=$(tail -c $((${sizeoff_t}*2)) "${src}" | head -c ${sizeoff_t} | hexdump -e \"%i\")
1119
1120 # grab metadata for debug reasons
1121 local metafile=$(emktemp)
1122 tail -c +$((${metaskip}+1)) "${src}" > "${metafile}"
1123
1124 # rip out the final file name from the metadata
1125 local datafile=$(tail -c +$((${metaskip}+1)) "${src}" | strings | head -n 1)
1126 datafile=$(basename "${datafile}")
1127
1128 # now lets uncompress/untar the file if need be
1129 local tmpfile=$(emktemp)
1130 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1131
1132 local iscompressed=$(file -b "${tmpfile}")
1133 if [[ ${iscompressed:0:8} == "compress" ]] ; then
1134 iscompressed=1
1135 mv ${tmpfile}{,.Z}
1136 gunzip ${tmpfile}
1137 else
1138 iscompressed=0
1139 fi
1140 local istar=$(file -b "${tmpfile}")
1141 if [[ ${istar:0:9} == "POSIX tar" ]] ; then
1142 istar=1
1143 else
1144 istar=0
1145 fi
1146
1147 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
1148 #dd if=${src} ibs=${metaskip} count=1 \
1149 # | dd ibs=${tailskip} skip=1 \
1150 # | gzip -dc \
1151 # > ${datafile}
1152 if [ ${iscompressed} -eq 1 ] ; then
1153 if [ ${istar} -eq 1 ] ; then
1154 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1155 | head -c $((${metaskip}-${tailskip})) \
1156 | tar -xzf -
1157 else
1158 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1159 | head -c $((${metaskip}-${tailskip})) \
1160 | gzip -dc \
1161 > ${datafile}
1162 fi
1163 else
1164 if [ ${istar} -eq 1 ] ; then
1165 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1166 | head -c $((${metaskip}-${tailskip})) \
1167 | tar --no-same-owner -xf -
1168 else
1169 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1170 | head -c $((${metaskip}-${tailskip})) \
1171 > ${datafile}
1172 fi
1173 fi
1174 true
1175 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1176 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1177}
1178
1179# @FUNCTION: unpack_makeself
1180# @USAGE: [file to unpack] [offset] [tail|dd]
1181# @DESCRIPTION:
1182# Unpack those pesky makeself generated files ...
1183# They're shell scripts with the binary package tagged onto
1184# the end of the archive. Loki utilized the format as does
1185# many other game companies.
1186#
1187# If the file is not specified, then ${A} is used. If the
1188# offset is not specified then we will attempt to extract
1189# the proper offset from the script itself.
1190unpack_makeself() {
1191 local src_input=${1:-${A}}
1192 local src=$(find_unpackable_file "${src_input}")
1193 local skip=$2
1194 local exe=$3
1195
1196 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1197
1198 local shrtsrc=$(basename "${src}")
1199 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1200 if [[ -z ${skip} ]] ; then
1201 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}')
1202 local skip=0
1203 exe=tail
1204 case ${ver} in 988 case ${size} in
1205 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 989 16|22|24|32|36|48|64|72|96|128|192|256)
1206 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 990 size=${size}x${size};;
1207 ;; 991 scalable)
1208 2.0|2.0.1)
1209 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1210 ;;
1211 2.1.1)
1212 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1213 let skip="skip + 1"
1214 ;;
1215 2.1.2)
1216 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1217 let skip="skip + 1"
1218 ;;
1219 2.1.3)
1220 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1221 let skip="skip + 1"
1222 ;;
1223 2.1.4|2.1.5)
1224 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1225 skip=$(head -n ${skip} "${src}" | wc -c)
1226 exe="dd"
1227 ;; 992 ;;
1228 *) 993 *)
1229 eerror "I'm sorry, but I was unable to support the Makeself file." 994 eerror "${size} is an unsupported icon size!"
1230 eerror "The version I detected was '${ver}'." 995 exit 1;;
1231 eerror "Please file a bug about the file ${shrtsrc} at"
1232 eerror "http://bugs.gentoo.org/ so that support can be added."
1233 die "makeself version '${ver}' not supported"
1234 ;;
1235 esac 996 esac
1236 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 997 shift 2;;
1237 fi 998 -t|--theme)
1238 case ${exe} in 999 theme=${2}
1239 tail) exe="tail -n +${skip} '${src}'";; 1000 shift 2;;
1240 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1001 -c|--context)
1241 *) die "makeself cant handle exe '${exe}'" 1002 context=${2}
1242 esac 1003 shift 2;;
1243
1244 # lets grab the first few bytes of the file to figure out what kind of archive it is
1245 local tmpfile=$(emktemp)
1246 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1247 local filetype=$(file -b "${tmpfile}")
1248 case ${filetype} in
1249 *tar\ archive*)
1250 eval ${exe} | tar --no-same-owner -xf -
1251 ;;
1252 bzip2*)
1253 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1254 ;;
1255 gzip*)
1256 eval ${exe} | tar --no-same-owner -xzf -
1257 ;;
1258 compress*)
1259 eval ${exe} | gunzip | tar --no-same-owner -xf -
1260 ;;
1261 *) 1004 *)
1262 eerror "Unknown filetype \"${filetype}\" ?"
1263 false
1264 ;;
1265 esac
1266 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1267}
1268
1269# @FUNCTION: check_license
1270# @USAGE: [license]
1271# @DESCRIPTION:
1272# Display a license for user to accept. If no license is
1273# specified, then ${LICENSE} is used.
1274check_license() {
1275 local lic=$1
1276 if [ -z "${lic}" ] ; then
1277 lic="${PORTDIR}/licenses/${LICENSE}"
1278 else
1279 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
1280 lic="${PORTDIR}/licenses/${lic}"
1281 elif [ -e "${PWD}/${lic}" ] ; then
1282 lic="${PWD}/${lic}"
1283 elif [ -e "${lic}" ] ; then
1284 lic="${lic}"
1285 fi
1286 fi
1287 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1288 local l="`basename ${lic}`"
1289
1290 # here is where we check for the licenses the user already
1291 # accepted ... if we don't find a match, we make the user accept
1292 local shopts=$-
1293 local alic
1294 set -o noglob #so that bash doesn't expand "*"
1295 for alic in ${ACCEPT_LICENSE} ; do
1296 if [[ ${alic} == ${l} ]]; then
1297 set +o noglob; set -${shopts} #reset old shell opts
1298 return 0
1299 fi
1300 done
1301 set +o noglob; set -$shopts #reset old shell opts
1302
1303 local licmsg=$(emktemp)
1304 cat <<-EOF > ${licmsg}
1305 **********************************************************
1306 The following license outlines the terms of use of this
1307 package. You MUST accept this license for installation to
1308 continue. When you are done viewing, hit 'q'. If you
1309 CTRL+C out of this, the install will not run!
1310 **********************************************************
1311
1312 EOF
1313 cat ${lic} >> ${licmsg}
1314 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1315 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1316 read alic
1317 case ${alic} in
1318 yes|Yes|y|Y)
1319 return 0
1320 ;;
1321 *)
1322 echo;echo;echo
1323 eerror "You MUST accept the license to continue! Exiting!"
1324 die "Failed to accept license"
1325 ;;
1326 esac
1327}
1328
1329# @FUNCTION: cdrom_get_cds
1330# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1331# @DESCRIPTION:
1332# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1333# the whole 'non-interactive' policy, but damnit I want CD support !
1334#
1335# With these cdrom functions we handle all the user interaction and
1336# standardize everything. All you have to do is call cdrom_get_cds()
1337# and when the function returns, you can assume that the cd has been
1338# found at CDROM_ROOT.
1339#
1340# The function will attempt to locate a cd based upon a file that is on
1341# the cd. The more files you give this function, the more cds
1342# the cdrom functions will handle.
1343#
1344# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1345# etc... If you want to give the cds better names, then just export
1346# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1347# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1348# also use the CDROM_NAME_SET bash array.
1349#
1350# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1351cdrom_get_cds() {
1352 # first we figure out how many cds we're dealing with by
1353 # the # of files they gave us
1354 local cdcnt=0
1355 local f=
1356 for f in "$@" ; do
1357 ((++cdcnt))
1358 export CDROM_CHECK_${cdcnt}="$f"
1359 done
1360 export CDROM_TOTAL_CDS=${cdcnt}
1361 export CDROM_CURRENT_CD=1
1362
1363 # now we see if the user gave use CD_ROOT ...
1364 # if they did, let's just believe them that it's correct
1365 if [[ -n ${CD_ROOT}${CD_ROOT_1} ]] ; then
1366 local var=
1367 cdcnt=0
1368 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1369 ((++cdcnt))
1370 var="CD_ROOT_${cdcnt}"
1371 [[ -z ${!var} ]] && var="CD_ROOT"
1372 if [[ -z ${!var} ]] ; then 1005 if [[ -z ${size} ]] ; then
1373 eerror "You must either use just the CD_ROOT" 1006 insinto /usr/share/pixmaps
1374 eerror "or specify ALL the CD_ROOT_X variables." 1007 else
1375 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables." 1008 insinto /usr/share/icons/${theme}/${size}/${context}
1376 die "could not locate CD_ROOT_${cdcnt}"
1377 fi 1009 fi
1378 done
1379 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1380 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1381 export CDROM_SET=-1
1382 for f in ${CDROM_CHECK_1//:/ } ; do
1383 ((++CDROM_SET))
1384 [[ -e ${CD_ROOT}/${f} ]] && break
1385 done
1386 export CDROM_MATCH=${f}
1387 return
1388 fi
1389 1010
1390 # User didn't help us out so lets make sure they know they can 1011 if [[ ${funcname} == doicon ]] ; then
1391 # simplify the whole process ...
1392 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1393 einfo "This ebuild will need the ${CDROM_NAME:-cdrom for ${PN}}"
1394 echo
1395 einfo "If you do not have the CD, but have the data files"
1396 einfo "mounted somewhere on your filesystem, just export"
1397 einfo "the variable CD_ROOT so that it points to the"
1398 einfo "directory containing the files."
1399 echo
1400 einfo "For example:"
1401 einfo "export CD_ROOT=/mnt/cdrom"
1402 echo
1403 else
1404 if [[ -n ${CDROM_NAME_SET} ]] ; then
1405 # Translate the CDROM_NAME_SET array into CDROM_NAME_#
1406 cdcnt=0
1407 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1408 ((++cdcnt))
1409 export CDROM_NAME_${cdcnt}="${CDROM_NAME_SET[$((${cdcnt}-1))]}"
1410 done
1411 fi
1412
1413 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1414 cdcnt=0
1415 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1416 ((++cdcnt))
1417 var="CDROM_NAME_${cdcnt}"
1418 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1419 done
1420 echo
1421 einfo "If you do not have the CDs, but have the data files"
1422 einfo "mounted somewhere on your filesystem, just export"
1423 einfo "the following variables so they point to the right place:"
1424 einfon ""
1425 cdcnt=0
1426 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1427 ((++cdcnt))
1428 echo -n " CD_ROOT_${cdcnt}"
1429 done
1430 echo
1431 einfo "Or, if you have all the files in the same place, or"
1432 einfo "you only have one cdrom, you can export CD_ROOT"
1433 einfo "and that place will be used as the same data source"
1434 einfo "for all the CDs."
1435 echo
1436 einfo "For example:"
1437 einfo "export CD_ROOT_1=/mnt/cdrom"
1438 echo
1439 fi
1440
1441 export CDROM_SET=""
1442 export CDROM_CURRENT_CD=0
1443 cdrom_load_next_cd
1444}
1445
1446# @FUNCTION: cdrom_load_next_cd
1447# @DESCRIPTION:
1448# Some packages are so big they come on multiple CDs. When you're done reading
1449# files off a CD and want access to the next one, just call this function.
1450# Again, all the messy details of user interaction are taken care of for you.
1451# Once this returns, just read the variable CDROM_ROOT for the location of the
1452# mounted CD. Note that you can only go forward in the CD list, so make sure
1453# you only call this function when you're done using the current CD.
1454cdrom_load_next_cd() {
1455 local var
1456 ((++CDROM_CURRENT_CD))
1457
1458 unset CDROM_ROOT
1459 var=CD_ROOT_${CDROM_CURRENT_CD}
1460 [[ -z ${!var} ]] && var="CD_ROOT"
1461 if [[ -z ${!var} ]] ; then 1012 if [[ -f $1 ]] ; then
1462 var="CDROM_CHECK_${CDROM_CURRENT_CD}" 1013 doins "${1}"
1463 _cdrom_locate_file_on_cd ${!var} 1014 elif [[ -d $1 ]] ; then
1464 else 1015 shopt -s nullglob
1465 export CDROM_ROOT=${!var} 1016 doins "${1}"/*.{png,svg}
1466 fi 1017 shopt -u nullglob
1467
1468 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1469}
1470
1471# this is used internally by the cdrom_get_cds() and cdrom_load_next_cd()
1472# functions. this should *never* be called from an ebuild.
1473# all it does is try to locate a give file on a cd ... if the cd isn't
1474# found, then a message asking for the user to insert the cdrom will be
1475# displayed and we'll hang out here until:
1476# (1) the file is found on a mounted cdrom
1477# (2) the user hits CTRL+C
1478_cdrom_locate_file_on_cd() {
1479 local mline=""
1480 local showedmsg=0 showjolietmsg=0
1481
1482 while [[ -z ${CDROM_ROOT} ]] ; do
1483 local i=0
1484 local -a cdset=(${*//:/ })
1485 if [[ -n ${CDROM_SET} ]] ; then
1486 cdset=(${cdset[${CDROM_SET}]})
1487 fi
1488
1489 while [[ -n ${cdset[${i}]} ]] ; do
1490 local dir=$(dirname ${cdset[${i}]})
1491 local file=$(basename ${cdset[${i}]})
1492
1493 local point= node= fs= foo=
1494 while read point node fs foo ; do
1495 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1496 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1497 && continue
1498 point=${point//\040/ }
1499 [[ ! -d ${point}/${dir} ]] && continue
1500 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1501 export CDROM_ROOT=${point}
1502 export CDROM_SET=${i}
1503 export CDROM_MATCH=${cdset[${i}]}
1504 return
1505 done <<< "$(get_mounts)"
1506
1507 ((++i))
1508 done
1509
1510 echo
1511 if [[ ${showedmsg} -eq 0 ]] ; then
1512 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1513 if [[ -z ${CDROM_NAME} ]] ; then
1514 einfo "Please insert+mount the cdrom for ${PN} now !"
1515 else 1018 else
1516 einfo "Please insert+mount the ${CDROM_NAME} cdrom now !" 1019 eerror "${1} is not a valid file/directory!"
1020 exit 1
1517 fi 1021 fi
1518 else 1022 else
1519 if [[ -z ${CDROM_NAME_1} ]] ; then 1023 break
1520 einfo "Please insert+mount cd #${CDROM_CURRENT_CD} for ${PN} now !"
1521 else
1522 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1523 einfo "Please insert+mount the ${!var} cdrom now !"
1524 fi
1525 fi 1024 fi
1526 showedmsg=1 1025 shift 1;;
1527 fi 1026 esac
1528 einfo "Press return to scan for the cd again"
1529 einfo "or hit CTRL+C to abort the emerge."
1530 echo
1531 if [[ ${showjolietmsg} -eq 0 ]] ; then
1532 showjolietmsg=1
1533 else
1534 ewarn "If you are having trouble with the detection"
1535 ewarn "of your CD, it is possible that you do not have"
1536 ewarn "Joliet support enabled in your kernel. Please"
1537 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1538 ebeep 5
1539 fi
1540 read || die "something is screwed with your system"
1541 done 1027 done
1028 if [[ ${funcname} == newicon ]] ; then
1029 newins "$@"
1030 fi
1031 ) || die
1032}
1033
1034# @FUNCTION: doicon
1035# @USAGE: [options] <icons>
1036# @DESCRIPTION:
1037# Install icon into the icon directory /usr/share/icons or into
1038# /usr/share/pixmaps if "--size" is not set.
1039# This is useful in conjunction with creating desktop/menu files.
1040#
1041# @CODE
1042# options:
1043# -s, --size
1044# !!! must specify to install into /usr/share/icons/... !!!
1045# size of the icon, like 48 or 48x48
1046# supported icon sizes are:
1047# 16 22 24 32 36 48 64 72 96 128 192 256 scalable
1048# -c, --context
1049# defaults to "apps"
1050# -t, --theme
1051# defaults to "hicolor"
1052#
1053# icons: list of icons
1054#
1055# example 1: doicon foobar.png fuqbar.svg suckbar.png
1056# results in: insinto /usr/share/pixmaps
1057# doins foobar.png fuqbar.svg suckbar.png
1058#
1059# example 2: doicon -s 48 foobar.png fuqbar.png blobbar.png
1060# results in: insinto /usr/share/icons/hicolor/48x48/apps
1061# doins foobar.png fuqbar.png blobbar.png
1062# @CODE
1063doicon() {
1064 _iconins ${FUNCNAME} "$@"
1065}
1066
1067# @FUNCTION: newicon
1068# @USAGE: [options] <icon> <newname>
1069# @DESCRIPTION:
1070# Like doicon, install the specified icon as newname.
1071#
1072# @CODE
1073# example 1: newicon foobar.png NEWNAME.png
1074# results in: insinto /usr/share/pixmaps
1075# newins foobar.png NEWNAME.png
1076#
1077# example 2: newicon -s 48 foobar.png NEWNAME.png
1078# results in: insinto /usr/share/icons/hicolor/48x48/apps
1079# newins foobar.png NEWNAME.png
1080# @CODE
1081newicon() {
1082 _iconins ${FUNCNAME} "$@"
1542} 1083}
1543 1084
1544# @FUNCTION: strip-linguas 1085# @FUNCTION: strip-linguas
1545# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>] 1086# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1546# @DESCRIPTION: 1087# @DESCRIPTION:
1553# of the lists. 1094# of the lists.
1554strip-linguas() { 1095strip-linguas() {
1555 local ls newls nols 1096 local ls newls nols
1556 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1097 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1557 local op=$1; shift 1098 local op=$1; shift
1558 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift 1099 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1559 local d f 1100 local d f
1560 for d in "$@" ; do 1101 for d in "$@" ; do
1561 if [[ ${op} == "-u" ]] ; then 1102 if [[ ${op} == "-u" ]] ; then
1562 newls=${ls} 1103 newls=${ls}
1563 else 1104 else
1564 newls="" 1105 newls=""
1565 fi 1106 fi
1566 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do 1107 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1567 if [[ ${op} == "-i" ]] ; then 1108 if [[ ${op} == "-i" ]] ; then
1568 hasq ${f} ${ls} && newls="${newls} ${f}" 1109 has ${f} ${ls} && newls="${newls} ${f}"
1569 else 1110 else
1570 hasq ${f} ${ls} || newls="${newls} ${f}" 1111 has ${f} ${ls} || newls="${newls} ${f}"
1571 fi 1112 fi
1572 done 1113 done
1573 ls=${newls} 1114 ls=${newls}
1574 done 1115 done
1575 else 1116 else
1577 fi 1118 fi
1578 1119
1579 nols="" 1120 nols=""
1580 newls="" 1121 newls=""
1581 for f in ${LINGUAS} ; do 1122 for f in ${LINGUAS} ; do
1582 if hasq ${f} ${ls} ; then 1123 if has ${f} ${ls} ; then
1583 newls="${newls} ${f}" 1124 newls="${newls} ${f}"
1584 else 1125 else
1585 nols="${nols} ${f}" 1126 nols="${nols} ${f}"
1586 fi 1127 fi
1587 done 1128 done
1588 [[ -n ${nols} ]] \ 1129 [[ -n ${nols} ]] \
1589 && ewarn "Sorry, but ${PN} does not support the LINGUAs:" ${nols} 1130 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1590 export LINGUAS=${newls:1} 1131 export LINGUAS=${newls:1}
1591} 1132}
1592 1133
1593# @FUNCTION: preserve_old_lib 1134# @FUNCTION: preserve_old_lib
1594# @USAGE: <libs to preserve> [more libs] 1135# @USAGE: <libs to preserve> [more libs]
1642 ewarn "the libraries are not being removed. You need to run revdep-rebuild" 1183 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1643 ewarn "in order to remove these old dependencies. If you do not have this" 1184 ewarn "in order to remove these old dependencies. If you do not have this"
1644 ewarn "helper program, simply emerge the 'gentoolkit' package." 1185 ewarn "helper program, simply emerge the 'gentoolkit' package."
1645 ewarn 1186 ewarn
1646 fi 1187 fi
1647 ewarn " # revdep-rebuild --library ${lib##*/}" 1188 ewarn " # revdep-rebuild --library '${lib}' && rm '${lib}'"
1648 done 1189 done
1649 if [[ ${notice} -eq 1 ]] ; then
1650 ewarn
1651 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1652 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1653 for lib in "$@" ; do
1654 ewarn " # rm '${lib}'"
1655 done
1656 fi
1657} 1190}
1658 1191
1659# @FUNCTION: built_with_use 1192# @FUNCTION: built_with_use
1660# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags> 1193# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1661# @DESCRIPTION: 1194# @DESCRIPTION:
1195#
1196# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1197#
1662# A temporary hack until portage properly supports DEPENDing on USE 1198# A temporary hack until portage properly supports DEPENDing on USE
1663# flags being enabled in packages. This will check to see if the specified 1199# flags being enabled in packages. This will check to see if the specified
1664# DEPEND atom was built with the specified list of USE flags. The 1200# DEPEND atom was built with the specified list of USE flags. The
1665# --missing option controls the behavior if called on a package that does 1201# --missing option controls the behavior if called on a package that does
1666# not actually support the defined USE flags (aka listed in IUSE). 1202# not actually support the defined USE flags (aka listed in IUSE).
1753# http://bugs.gentoo.org/73450 1289# http://bugs.gentoo.org/73450
1754epunt_cxx() { 1290epunt_cxx() {
1755 local dir=$1 1291 local dir=$1
1756 [[ -z ${dir} ]] && dir=${S} 1292 [[ -z ${dir} ]] && dir=${S}
1757 ebegin "Removing useless C++ checks" 1293 ebegin "Removing useless C++ checks"
1758 local f 1294 local f p any_found
1759 find "${dir}" -name configure | while read f ; do 1295 while IFS= read -r -d '' f; do
1760 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1296 for p in "${PORTDIR}"/eclass/ELT-patches/nocxx/*.patch ; do
1297 if patch --no-backup-if-mismatch -p1 "${f}" "${p}" >/dev/null ; then
1298 any_found=1
1299 break
1300 fi
1761 done 1301 done
1302 done < <(find "${dir}" -name configure -print0)
1303
1304 if [[ -z ${any_found} ]]; then
1305 eqawarn "epunt_cxx called unnecessarily (no C++ checks to punt)."
1306 fi
1762 eend 0 1307 eend 0
1763} 1308}
1764 1309
1765# @FUNCTION: make_wrapper 1310# @FUNCTION: make_wrapper
1766# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath] 1311# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1770# first optionally setting LD_LIBRARY_PATH to the colon-delimited 1315# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1771# libpaths followed by optionally changing directory to chdir. 1316# libpaths followed by optionally changing directory to chdir.
1772make_wrapper() { 1317make_wrapper() {
1773 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1318 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1774 local tmpwrapper=$(emktemp) 1319 local tmpwrapper=$(emktemp)
1320
1321 (
1322 echo '#!/bin/sh'
1323 [[ -n ${chdir} ]] && printf 'cd "%s"\n' "${chdir}"
1324 if [[ -n ${libdir} ]] ; then
1325 cat <<-EOF
1326 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1327 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1328 else
1329 export LD_LIBRARY_PATH="${libdir}"
1330 fi
1331 EOF
1332 fi
1775 # We don't want to quote ${bin} so that people can pass complex 1333 # We don't want to quote ${bin} so that people can pass complex
1776 # things as $bin ... "./someprog --args" 1334 # things as ${bin} ... "./someprog --args"
1335 printf 'exec %s "$@"\n' "${bin}"
1777 cat << EOF > "${tmpwrapper}" 1336 ) > "${tmpwrapper}"
1778#!/bin/sh
1779cd "${chdir:-.}"
1780if [ -n "${libdir}" ] ; then
1781 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1782 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1783 else
1784 export LD_LIBRARY_PATH="${libdir}"
1785 fi
1786fi
1787exec ${bin} "\$@"
1788EOF
1789 chmod go+rx "${tmpwrapper}" 1337 chmod go+rx "${tmpwrapper}"
1338
1790 if [[ -n ${path} ]] ; then 1339 if [[ -n ${path} ]] ; then
1791 ( 1340 (
1792 exeinto "${path}" 1341 exeinto "${path}"
1793 newexe "${tmpwrapper}" "${wrapper}" 1342 newexe "${tmpwrapper}" "${wrapper}"
1794 ) || die 1343 ) || die
1795 else 1344 else
1796 newbin "${tmpwrapper}" "${wrapper}" || die 1345 newbin "${tmpwrapper}" "${wrapper}" || die
1797 fi 1346 fi
1798} 1347}
1348
1349# @FUNCTION: path_exists
1350# @USAGE: [-a|-o] <paths>
1351# @DESCRIPTION:
1352# Check if the specified paths exist. Works for all types of paths
1353# (files/dirs/etc...). The -a and -o flags control the requirements
1354# of the paths. They correspond to "and" and "or" logic. So the -a
1355# flag means all the paths must exist while the -o flag means at least
1356# one of the paths must exist. The default behavior is "and". If no
1357# paths are specified, then the return value is "false".
1358path_exists() {
1359 local opt=$1
1360 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1361
1362 # no paths -> return false
1363 # same behavior as: [[ -e "" ]]
1364 [[ $# -eq 0 ]] && return 1
1365
1366 local p r=0
1367 for p in "$@" ; do
1368 [[ -e ${p} ]]
1369 : $(( r += $? ))
1370 done
1371
1372 case ${opt} in
1373 -a) return $(( r != 0 )) ;;
1374 -o) return $(( r == $# )) ;;
1375 esac
1376}
1377
1378# @FUNCTION: in_iuse
1379# @USAGE: <flag>
1380# @DESCRIPTION:
1381# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1382# as necessary.
1383#
1384# Note that this function should not be used in the global scope.
1385in_iuse() {
1386 debug-print-function ${FUNCNAME} "${@}"
1387 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1388
1389 local flag=${1}
1390 local liuse=( ${IUSE} )
1391
1392 has "${flag}" "${liuse[@]#[+-]}"
1393}
1394
1395# @FUNCTION: use_if_iuse
1396# @USAGE: <flag>
1397# @DESCRIPTION:
1398# Return true if the given flag is in USE and IUSE.
1399#
1400# Note that this function should not be used in the global scope.
1401use_if_iuse() {
1402 in_iuse $1 || return 1
1403 use $1
1404}
1405
1406# @FUNCTION: usex
1407# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1408# @DESCRIPTION:
1409# Proxy to declare usex for package managers or EAPIs that do not provide it
1410# and use the package manager implementation when available (i.e. EAPI >= 5).
1411# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1412# otherwise echo [false output][false suffix] (defaults to "no").
1413if has "${EAPI:-0}" 0 1 2 3 4; then
1414 usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1415fi
1416
1417# @FUNCTION: prune_libtool_files
1418# @USAGE: [--all|--modules]
1419# @DESCRIPTION:
1420# Locate unnecessary libtool files (.la) and libtool static archives
1421# (.a) and remove them from installation image.
1422#
1423# By default, .la files are removed whenever the static linkage can
1424# either be performed using pkg-config or doesn't introduce additional
1425# flags.
1426#
1427# If '--modules' argument is passed, .la files for modules (plugins) are
1428# removed as well. This is usually useful when the package installs
1429# plugins and the plugin loader does not use .la files.
1430#
1431# If '--all' argument is passed, all .la files are removed without
1432# performing any heuristic on them. You shouldn't ever use that,
1433# and instead report a bug in the algorithm instead.
1434#
1435# The .a files are only removed whenever corresponding .la files state
1436# that they should not be linked to, i.e. whenever these files
1437# correspond to plugins.
1438#
1439# Note: if your package installs both static libraries and .pc files
1440# which use variable substitution for -l flags, you need to add
1441# pkg-config to your DEPEND.
1442prune_libtool_files() {
1443 debug-print-function ${FUNCNAME} "$@"
1444
1445 local removing_all removing_modules opt
1446 for opt; do
1447 case "${opt}" in
1448 --all)
1449 removing_all=1
1450 removing_modules=1
1451 ;;
1452 --modules)
1453 removing_modules=1
1454 ;;
1455 *)
1456 die "Invalid argument to ${FUNCNAME}(): ${opt}"
1457 esac
1458 done
1459
1460 local f
1461 local queue=()
1462 while IFS= read -r -d '' f; do # for all .la files
1463 local archivefile=${f/%.la/.a}
1464
1465 # The following check is done by libtool itself.
1466 # It helps us avoid removing random files which match '*.la',
1467 # see bug #468380.
1468 if ! sed -n -e '/^# Generated by .*libtool/q0;4q1' "${f}"; then
1469 continue
1470 fi
1471
1472 [[ ${f} != ${archivefile} ]] || die 'regex sanity check failed'
1473 local reason pkgconfig_scanned
1474 local snotlink=$(sed -n -e 's:^shouldnotlink=::p' "${f}")
1475
1476 if [[ ${snotlink} == yes ]]; then
1477
1478 # Remove static libs we're not supposed to link against.
1479 if [[ -f ${archivefile} ]]; then
1480 einfo "Removing unnecessary ${archivefile#${D%/}} (static plugin)"
1481 queue+=( "${archivefile}" )
1482 fi
1483
1484 # The .la file may be used by a module loader, so avoid removing it
1485 # unless explicitly requested.
1486 if [[ ${removing_modules} ]]; then
1487 reason='module'
1488 fi
1489
1490 else
1491
1492 # Remove .la files when:
1493 # - user explicitly wants us to remove all .la files,
1494 # - respective static archive doesn't exist,
1495 # - they are covered by a .pc file already,
1496 # - they don't provide any new information (no libs & no flags).
1497
1498 if [[ ${removing_all} ]]; then
1499 reason='requested'
1500 elif [[ ! -f ${archivefile} ]]; then
1501 reason='no static archive'
1502 elif [[ ! $(sed -nre \
1503 "s/^(dependency_libs|inherited_linker_flags)='(.*)'$/\2/p" \
1504 "${f}") ]]; then
1505 reason='no libs & flags'
1506 else
1507 if [[ ! ${pkgconfig_scanned} ]]; then
1508 # Create a list of all .pc-covered libs.
1509 local pc_libs=()
1510 if [[ ! ${removing_all} ]]; then
1511 local pc
1512 local tf=${T}/prune-lt-files.pc
1513 local pkgconf=$(tc-getPKG_CONFIG)
1514
1515 while IFS= read -r -d '' pc; do # for all .pc files
1516 local arg libs
1517
1518 # Use pkg-config if available (and works),
1519 # fallback to sed.
1520 if ${pkgconf} --exists "${pc}" &>/dev/null; then
1521 sed -e '/^Requires:/d' "${pc}" > "${tf}"
1522 libs=$(${pkgconf} --libs "${tf}")
1523 else
1524 libs=$(sed -ne 's/^Libs://p' "${pc}")
1525 fi
1526
1527 for arg in ${libs}; do
1528 if [[ ${arg} == -l* ]]; then
1529 if [[ ${arg} == '*$*' ]]; then
1530 eqawarn "${FUNCNAME}: variable substitution likely failed in ${pc}"
1531 eqawarn "(arg: ${arg})"
1532 eqawarn "Most likely, you need to add virtual/pkgconfig to DEPEND."
1533 fi
1534
1535 pc_libs+=( lib${arg#-l}.la )
1536 fi
1537 done
1538 done < <(find "${D}" -type f -name '*.pc' -print0)
1539
1540 rm -f "${tf}"
1541 fi
1542
1543 pkgconfig_scanned=1
1544 fi # pkgconfig_scanned
1545
1546 has "${f##*/}" "${pc_libs[@]}" && reason='covered by .pc'
1547 fi # removal due to .pc
1548
1549 fi # shouldnotlink==no
1550
1551 if [[ ${reason} ]]; then
1552 einfo "Removing unnecessary ${f#${D%/}} (${reason})"
1553 queue+=( "${f}" )
1554 fi
1555 done < <(find "${D}" -xtype f -name '*.la' -print0)
1556
1557 if [[ ${queue[@]} ]]; then
1558 rm -f "${queue[@]}"
1559 fi
1560}
1561
1562check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1563
1564fi

Legend:
Removed from v.1.302  
changed lines
  Added in v.1.421

  ViewVC Help
Powered by ViewVC 1.1.20